//#include "mpi.h"
import mpi.*;

//#define NUM_DIMS 2

//int main( argc, argv )
//int argc;
//char **argv;
class cart {

  static public void main(String[] args) {
    final int NUM_DIMS = 2;

    //MPI_Init( &argc, &argv );
    MPI.Init(args);

    int              rank, size, i;
    int              errors=0;
    //int              dims[NUM_DIMS];
    int dims[]    =  new int[NUM_DIMS];
    //int              periods[NUM_DIMS];
    boolean periods[] =  new boolean[NUM_DIMS];
    //int              coords[NUM_DIMS];
    int coords[]  =  new int[NUM_DIMS];
    //int              new_coords[NUM_DIMS];
    int new_coords[] = new int[NUM_DIMS];
    //int              reorder = 1;
    boolean            reorder = false;
    //MPI_Comm         comm_temp, comm_cart, new_comm;
    //Cartcomm         comm_cart, comm_temp, new_comm;
    int              topo_status;
    int              ndims;
    int              new_rank;
    //int              remain_dims[NUM_DIMS];
    boolean remain_dims[] = new boolean[NUM_DIMS];
    int              newnewrank;

    //MPI_Comm_rank( MPI_COMM_WORLD, &rank );
    rank = MPI.COMM_WORLD.Rank();
    //MPI_Comm_size( MPI_COMM_WORLD, &size );
    size = MPI.COMM_WORLD.Size();

    /* Clear dims array and get dims for topology */
    for(i=0;i<NUM_DIMS;i++) { dims[i] = 0; periods[i] = false; }
    //MPI_Dims_create ( size, NUM_DIMS, dims );
    dims = Cartcomm.Dims_create( size, NUM_DIMS );

    /* Make a new communicator with a topology */
    //MPI_Cart_create ( MPI_COMM_WORLD, 2, dims, periods, reorder, &comm_temp );
    Cartcomm comm_temp = MPI.COMM_WORLD.Create_cart(dims, periods, reorder);
    //MPI_Comm_dup ( comm_temp, &comm_cart );
    Comm comm_cart = comm_temp.Dup();

    /* Determine the status of the new communicator */
    //MPI_Topo_test ( comm_cart, &topo_status );
    topo_status = comm_cart.Topo_test();
    if (topo_status != MPI.CART) errors++;

    /* How many dims do we have? */
    /*****************************************
   //MPI_Cartdim_get( comm_cart, &ndims );
    ndims = comm_cart.Get()....dims;
    if ( ndims != NUM_DIMS ) errors++;
    ******************************************/


    // Get the topology, does it agree with what we put in? 
    for(i=0;i<NUM_DIMS;i++) { dims[i] = 0; periods[i] = false; }
    //MPI_Cart_get ( comm_cart, NUM_DIMS, dims, periods, coords );
    coords = comm_cart.Get().coords;
    

    /* Does the mapping from coords to rank work? */
    //MPI_Cart_rank ( comm_cart, coords, &new_rank );
    new_rank = comm_cart.Rank ( coords );
    if ( new_rank != rank ) errors++;

    /* Does the mapping from rank to coords work */
    //MPI_Cart_coords ( comm_cart, rank, NUM_DIMS, new_coords );
    new_coords = comm_cart.Coords( rank );
    for (i=0;i<NUM_DIMS;i++) 
      if ( coords[i] != new_coords[i] ) 
	errors++;

    /* Let's shift in each dimension and see how it works!   */
    /* Because it's late and I'm tired, I'm not making this  */
    /* automatically test itself.                            */
    for (i=0;i<NUM_DIMS;i++) {
      int source, dest;
      //MPI_Cart_shift(comm_cart, i, 1, &source, &dest);
      source = comm_cart.Shift(i, 1).rank_source;
      dest   = comm_cart.Shift(i, 1).rank_dest;
      System.out.println
	(rank+" Shifting 1 in the "+i+" dimension");
      System.out.println
	(rank+" source = "+source+",  dest = "); 
    }

    /* Subdivide */
    remain_dims[0] = false; 
    for (i=1; i<NUM_DIMS; i++) remain_dims[i] = true;
    //MPI_Cart_sub ( comm_cart, remain_dims, &new_comm );
    Cartcomm new_comm = comm_cart.Sub(remain_dims);

    /* Determine the status of the new communicator */
    //MPI_Topo_test ( new_comm, &topo_status );
    topo_status = new_comm.Topo_test();
    if (topo_status != MPI.CART) errors++;

    /* How many dims do we have? */
    /****************************************
    MPI_Cartdim_get( new_comm, &ndims );
    if ( ndims != NUM_DIMS-1 ) errors++;
    *****************************************/


    /* Get the topology, does it agree with what we put in? */
    //??? do we need  for(..)....
    for(i=0;i<NUM_DIMS-1;i++) { dims[i] = 0; periods[i] = false; } 
    //MPI_Cart_get ( new_comm, ndims, dims, periods, coords );
    coords = new_comm.Get().coords;

    /* Does the mapping from coords to rank work? */
    //MPI_Comm_rank ( new_comm, &newnewrank );
    newnewrank = new_comm.Rank();
    //MPI_Cart_rank ( new_comm, coords, &new_rank );
    new_rank = new_comm.Rank(coords);
    if ( new_rank != newnewrank ) errors++;

    /* Does the mapping from rank to coords work */
    // ????????????
    //MPI_Cart_coords ( new_comm, new_rank, NUM_DIMS -1, new_coords );
    new_coords = new_comm.Get().coords;
    for (i=0;i<NUM_DIMS-1;i++) 
      if ( coords[i] != new_coords[i] ) 
	errors++;

    /* We're at the end */
    /*
    MPI_Comm_free( &new_comm );
    MPI_Comm_free( &comm_temp );
    MPI_Comm_free( &comm_cart );
    */
    //Test_Waitforall( );  ????????????????????
    if (errors != 0) System.out.println
		  ("["+rank+"] done with "+errors+" ERRORS!");
    MPI.Finalize();

  }
}


